#include <iostream>
#include <vector>
using namespace std;
typedef long long ll;
const ll maxn = 2e6+10, inf = 1e15;
ll cost[maxn], price[maxn], n;
ll index[maxn], min_price[maxn];
ll prefix[maxn];

void init(int k, vector < int > a, vector < int > b) {
    //cout << "call: " << a.size() << ' ' << k << '\n';
    n = a.size();
    for (ll i = 1 ; i <= n ; ++i) {
        cost[i] = a[i-1];
        if (i < n) {
            price[i+1] = b[i-1];
            prefix[i+1] = prefix[i] + price[i+1];
        }
    }
    ll l = 1, r = 1, currsum = 0;
    while (r <= n+1) {
        //cout << "l, r: " << l << ' ' << r << ' ' << currsum << ' ' << cost[l] << '\n';
        if (currsum - cost[l] >= k) {
            currsum -= cost[l];
            ++l;
        } else {
            min_price[r-1] = prefix[r-1] - prefix[l];
            index[r-1] = l - (currsum < k);
            currsum += cost[r];
            ++r;
        }
    }
    /*cout << "initialized: \n";
    for (ll i = 1 ; i <= n ; ++i)
        cout << i << ": " << index[i] << ' ' << min_price[i] << '\n';*/
}

int message(int k) {
    ll ans = inf;
    for (ll i = k ; i <= n ; ++i) {
        if (index[i] == 0) continue;
        if (index[i] <= k) {
            ans = min(ans, min_price[i]);
        } else {
            ans = min(ans, prefix[i] - prefix[k]);
        }
    }

    return ans;
}

/*
7 10
2 7 1 1 1 7 5
2 7 3 1 2 9
2
4 7
*/