#include <iostream>
#include <vector>
#include <limits.h>
#define ll int
using namespace std;
const ll maxn = 2e6+10, maxlog = 22, inf = INT_MAX;
ll cost[maxn], price[maxn], n;
ll index[maxn], min_price[maxn];
ll prefix[maxn];
ll first_bigger_index[maxn];
ll first_non_zero;
ll sparse[maxlog][maxn];

void init_index(int k) {
    ll l = 1, r = 1, currsum = 0;
    while (r <= n+1) {
        //cout << "l, r: " << l << ' ' << r << ' ' << currsum << ' ' << cost[l] << '\n';
        if (currsum - cost[l] >= k) {
            currsum -= cost[l];
            ++l;
        } else {
            min_price[r-1] = prefix[r-1] - prefix[l];
            index[r-1] = l - (currsum < k);
            if (index[r-1] > 0 && !first_non_zero) first_non_zero = r-1;
            currsum += cost[r];
            ++r;
        }
    }
}

void init_first_bigger() {
    //cout << "call first bigger\n";
    ll l = 1, r = 1; index[n+1] = inf;
    while (l <= n && r <= n+1) {
        if (index[r] <= l) ++r;
        else {
            first_bigger_index[l] = r;
            ++l;
        }
    }
}

int get_log[maxn];

void build_sparse() {
    for (int i = 1 ; i <= n ; ++i)
        sparse[0][i] = min_price[i];
    for (int log = 1 ; (1 << log) <= n ; ++log) {
        for (int i = 1 ; i + (1 << log) - 1 <= n ; ++i) {
            sparse[log][i] = min(sparse[log-1][i], sparse[log-1][i + (1 << (log-1))]);
            //cout << "build rmq: " << log << ' ' << i << ' ' << sparse[log][i] << '\n';
        } 
    }
    int currlog = 0;
    for (int i = 1 ; i <= n ; ++i) {
        if ((1 << (currlog+1)) < i) ++currlog;
        get_log[i] = currlog;
    }
}

ll get_min(int l, int r) {
    if (l > r) return inf;
    int logarithm = get_log[r-l+1];
    return min(sparse[logarithm][l], sparse[logarithm][r-(1 << logarithm)+1]);
}

void init(int k, vector < int > a, vector < int > b) {
    //cout << "call: " << a.size() << ' ' << k << '\n';
    n = a.size();
    for (ll i = 1 ; i <= n ; ++i) {
        cost[i] = a[i-1];
        if (i < n) {
            price[i+1] = b[i-1];
            prefix[i+1] = prefix[i] + price[i+1];
        }
    }


    init_index(k);
    init_first_bigger();
    build_sparse();

    /*cout << "initialized: \n";
    for (ll i = 1 ; i <= n ; ++i)
        cout << i << ": " << index[i] << ' ' << min_price[i] << '\n';*/

    /*cout << "first bigger index: \n";
    for (ll i = 1 ; i <= n ; ++i)
        cout << i << ": " << first_bigger_index[i] << '\n';*/
}

int message(int k) {
    ll rmq_l = max(k, first_non_zero);
    ll rmq_r = first_bigger_index[k]-1;
    //cout << "rmq query: " << rmq_l << ' ' << rmq_r << ' ' << get_min(rmq_l, rmq_r) << '\n';
    ll ans = get_min(rmq_l, rmq_r); 
    if (first_bigger_index[k] <= n) ans = min(ans, prefix[first_bigger_index[k]] - prefix[k]);
    return ans;
}

/*
7 10
2 7 1 1 1 7 5
2 7 3 1 2 9
2
4 7
*/