#include <iostream>
#include <vector>
#include <set>
#include <limits.h>
#pragma GCC optimize ("Ofast")
#pragma GCC target ("sse4")
#define ll int
using namespace std;
const ll maxn = 2e6+10, maxlog = 21, inf = INT_MAX;
ll cost[maxn], price[maxn], n;
ll index[maxn];
ll prefix[maxn];
ll first_bigger_index[maxn];
ll min_precalc[maxn];
ll first_non_zero;
ll ans[maxn];

inline void init_index(int k) {
    ll l = 1, r = 1, currsum = 0;
    while (r <= n+1) {
        //cout << "l, r: " << l << ' ' << r << ' ' << currsum << ' ' << cost[l] << '\n';
        if (currsum - cost[l] >= k) {
            currsum -= cost[l];
            ++l;
        } else {
            index[r-1] = l - (currsum < k);
            if (index[r-1] > 0 && !first_non_zero) first_non_zero = r-1;
            currsum += cost[r];
            ++r;
        }
    }
}

multiset < int > min_set;

inline void init_first_bigger() {
    //cout << "call first bigger\n";
    ll l = 1, r = 1; index[n+1] = inf;
    while (l <= n && r <= n+1) {
        if (index[r] <= l) {
            min_set.insert(prefix[r] - prefix[index[r]]);
            ++r;
        } else {
            first_bigger_index[l] = r;
            min_precalc[l] = (*min_set.begin());
            min_set.erase(min_set.find(prefix[l] - prefix[index[l]]));
            ++l;
        }
    }
}

inline int get_ans(int k) {
    //cout << "rmq query: " << rmq_l << ' ' << rmq_r << ' ' << get_min(rmq_l, rmq_r) << '\n';
    ll ans = min_precalc[k];
    if (first_bigger_index[k] <= n) ans = min(ans, prefix[first_bigger_index[k]] - prefix[k]);
    return ans;
}

void init(int k, vector < int > a, vector < int > b) {
    //cout << "call: " << a.size() << ' ' << k << '\n';
    n = a.size();
    for (ll i = 1 ; i <= n ; ++i) {
        cost[i] = a[i-1];
        if (i < n) {
            price[i+1] = b[i-1];
            prefix[i+1] = prefix[i] + price[i+1];
        }
    }


    init_index(k);
    init_first_bigger();

    /*cout << "initialized: \n";
    for (ll i = 1 ; i <= n ; ++i)
        cout << i << ": " << index[i] << ' ' << min_price[i] << '\n';*/

    /*cout << "first bigger index: \n";
    for (ll i = 1 ; i <= n ; ++i)
        cout << i << ": " << first_bigger_index[i] << '\n';*/
    for (int i = 1 ; i <= n ; ++i)
        ans[i] = get_ans(i);
}

int message(int k) {
    return ans[k];
}

/*
7 10
2 7 1 1 1 7 5
2 7 3 1 2 9
2
4 7
*/