#include <iostream>
#include <vector>
#include <limits.h>
#pragma GCC optimize ("Ofast")
#pragma GCC target ("sse4")
using namespace std;
const int maxn = 2e6+10, maxlog = 21, inf = INT_MAX;
int cost[maxn], price[maxn], n;
int index[maxn], min_price[maxn];
int prefix[maxn];
int first_bigger_index[maxn];
int first_non_zero;
int sparse[maxlog][maxn], max_diff;
int ans[maxn];
inline void init_index(int k) {
    int l = 1, r = 1, currsum = 0;
    while (r <= n+1) {
        //cout << "l, r: " << l << ' ' << r << ' ' << currsum << ' ' << cost[l] << '\n';
        if (currsum - cost[l] >= k) {
            currsum -= cost[l];
            ++l;
        } else {
            min_price[r-1] = prefix[r-1] - prefix[l];
            index[r-1] = l - (currsum < k);
            if (index[r-1] > 0 && !first_non_zero) first_non_zero = r-1;
            currsum += cost[r];
            ++r;
        }
    }
}
inline void init_first_bigger() {
    //cout << "caint first bigger\n";
    int l = 1, r = 1; index[n+1] = inf;
    while (l <= n) {
        if (index[r] <= l) ++r;
        else {
            first_bigger_index[l] = r;
            max_diff = max(max_diff, r-l);
            ++l;
        }
    }
}
int get_log[maxn];
inline void build_sparse() {
    for (int i = 1 ; i <= n ; ++i)
        sparse[0][i] = min_price[i];
    for (int log = 1 ; (1 << log) <= max_diff ; ++log) {
        for (int i = 1 ; i + (1 << log) - 1 <= n ; ++i) {
            sparse[log][i] = min(sparse[log-1][i], sparse[log-1][i + (1 << log-1)]);
            //cout << "build rmq: " << log << ' ' << i << ' ' << sparse[log][i] << '\n';
        } 
    }
    int currlog = 0;
    for (int i = 1 ; i <= max_diff ; ++i) {
        if ((1 << currlog+1) < i) ++currlog;
        get_log[i] = currlog;
    }
}
inline int get_min(int l, int r) {
    if (l > r) return inf;
    int logarithm = get_log[r-l+1];
    return min(sparse[logarithm][l], sparse[logarithm][r-(1 << logarithm)+1]);
}
inline int get_ans(int k) {
    int rmq_l = max(k, first_non_zero);
    int rmq_r = first_bigger_index[k]-1;
    //cout << "rmq query: " << rmq_l << ' ' << rmq_r << ' ' << get_min(rmq_l, rmq_r) << '\n';
    int ans = get_min(rmq_l, rmq_r); 
    if (first_bigger_index[k] <= n) ans = min(ans, prefix[first_bigger_index[k]] - prefix[k]);
    return ans;
}
void init(int k, vector < int > a, vector < int > b) {
    //cout << "caint: " << a.size() << ' ' << k << '\n';
    n = a.size();
    for (int i = 1 ; i <= n ; ++i) {
        cost[i] = a[i-1];
        if (i < n) {
            price[i+1] = b[i-1];
            prefix[i+1] = prefix[i] + price[i+1];
        }
    }
    init_index(k);
    init_first_bigger();
    build_sparse();
    /*cout << "initialized: \n";
    for (int i = 1 ; i <= n ; ++i)
        cout << i << ": " << index[i] << ' ' << min_price[i] << '\n';*/
    /*cout << "first bigger index: \n";
    for (int i = 1 ; i <= n ; ++i)
        cout << i << ": " << first_bigger_index[i] << '\n';*/
    fill(ans+1, ans+n+1, -1);
}
int message(int k) {
    if (ans[k] == -1) ans[k] = get_ans(k);
    return ans[k];
}
/*
7 10
2 7 1 1 1 7 5
2 7 3 1 2 9
2
4 7
*/